package data

import (
	"actatempus_backend/internal/domain/entities"
	"context"

	E "github.com/IBM/fp-go/either"
)

// UserDataSource defines the operations for interacting with user data.
type UserDataSource interface {
	Create(ctx context.Context, user entities.UserCreate) E.Either[error,entities.User]
	FindByID(ctx context.Context, id string) E.Either[error,entities.User]
	FindByEmail(ctx context.Context, email string) E.Either[error,entities.User]
	Update(ctx context.Context, user entities.UserUpdate) E.Either[error,entities.User]
	Delete(ctx context.Context, id string) E.Either[error,entities.User]
	FindAll(ctx context.Context) E.Either[error,[]entities.User]
}
